//+------------------------------------------------------------------+
//|                                             Third Experiment.mq4 |
//+------------------------------------------------------------------+
#property copyright "Phil Clarke"

extern int ProfitTarget = 10;
int buyorders;
double lots=0.01;
double uplimit;
double dnlimit;
double balance=0.0;
double b;
double a;
extern int range=20;
extern int trade=50;
double start;
bool stage1=true;
bool stage2=false;
double reset;
bool reset2;
extern int SMA=10;
extern int MMA=50;
extern int LMA=200;
datetime Time0=0;
int pt;
int magicnumber=12345;



int range1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {

            
            cycle1();
            cycle2();
            cycle3();

            Comment  ("                       Phil's System 2", 
                     "\n                      Account Balance     :   " + AccountBalance(),
                     "\n                      Account Equity       :   " + AccountEquity(),
                     "\n                      Total Orders         :   " + OrdersTotal());


   }   
      
      



//----------------------------- END OF START ROUTINE ----------------------------//


void cycle1()
   {
      onprofitclose();
   }


void cycle2()
   {
      if (OrdersTotal() == 0)
         {
            placebuyorders();
            b = MarketInfo(OrderSymbol(), MODE_BID);
            a = MarketInfo(OrderSymbol(), MODE_ASK);
            uplimit=b;
            dnlimit=a;
            balance=AccountEquity();
            start=a;
            stage1=true;
            stage2=false;
            range1=range;
            reset=true;
            reset2=true;
            pt=ProfitTarget;
          }
   }


void cycle3()
   {
            if ((OrdersTotal() > 0) && (OrdersTotal()<trade))
               {
                   b = MarketInfo(OrderSymbol(), MODE_BID);
                   a = MarketInfo(OrderSymbol(), MODE_ASK);

                  if (b > uplimit)
                     {
                        placesellorders();
                        uplimit = (b + 0.0010);
                     }
                  if (a < dnlimit)
                     {
                        placebuyorders();
                        dnlimit = (a - 0.0010);
                     }
               }
   }



void placesellorders()   
{
   OrderSend(Symbol(),OP_SELL,lots,Bid,3,0.0,0.0,"Sell Order",magicnumber,0.0,Red);
}


void placebuyorders()   
{
   OrderSend(Symbol(),OP_BUY,lots,Ask,3,0.0,0.0,"Buy Order",magicnumber,0.0,Blue);
}
 


void onprofitclose()
   {      
      int total  = OrdersTotal();      
      double MyCurrentProfit=0;      
      for (int cnt = 0 ; cnt < total ; cnt++)      
         {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
            if (OrderMagicNumber() == magicnumber) MyCurrentProfit += OrderProfit();
         }
      if(MyCurrentProfit>=ProfitTarget) CloseAll();
   }
   
void CloseAll()
   {
      int total  = OrdersTotal();
      for (int cnt = 0 ; cnt < total ; cnt++)
         {
            OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
            if (OrderMagicNumber() == magicnumber)
            if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,5,Yellow);
            if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,5,Yellow);
         }
   }




